#include <stdlib.h>
#include <stdint.h>
#include <math.h>
#include <alsa/asoundlib.h>

int main() {
    
    const static char device[] = "hw:0";
    const static snd_pcm_format_t format = SND_PCM_FORMAT_S16_LE;
    const static snd_pcm_access_t access = SND_PCM_ACCESS_RW_INTERLEAVED;
    const static unsigned int sampling_rate = 24000;
    const static unsigned int channels = 1;                 // Mono
    const static unsigned int soft_resample = 1;
    const static unsigned int latency = 100000;             // Latency 100000us
    const unsigned int buffer_size = 512;
    
    int x;
    int t;
    
    snd_pcm_t *pcm;
    int16_t buffer[ buffer_size ];

    snd_pcm_open( &pcm, device, SND_PCM_STREAM_PLAYBACK, 0 );
    
    snd_pcm_set_params(
                pcm, format, access,
                channels, sampling_rate, soft_resample, latency
                );
    
    for (x=0; x<100; x++) {
        
        // ------------------------------- サイン波の生成 -------------------------------
        for (t=0; t<512; t++) {
            buffer[t]=30000*sin(2*3.14159*t/16);
        }
        
        // -------------------------  ALSAバッファへサイン波出力 --------------------------
        int write_result = snd_pcm_writei ( pcm, ( const void* )buffer, buffer_size );
    }

    snd_pcm_close( pcm );
}
