#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/Xutil.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#define WIN_W     512
#define WIN_H     300
#define WIN_X     100
#define WIN_Y     100
#define BORDER    2

int main( void )
{
    Display*       dpy;             // Display
    Window         root;            // Root Window
    Window         win;             // Display Window
    int            screen;          // Screen
    unsigned long  black,white;     // Pixcel value
    GC             gc;              // Graphic Context
    XEvent         evt;             // Event strunc

    Colormap       cmap;            // Color map
    XColor         color, exact;
    unsigned long  green, red;
    unsigned long  aqua, navy;
    
    KeySym keysym;

    int n;
    
    dpy = XOpenDisplay( "" );

    root   = DefaultRootWindow( dpy );
    screen = DefaultScreen( dpy );

    cmap   = DefaultColormap( dpy, screen );

    white  = WhitePixel( dpy, screen );
    black  = BlackPixel( dpy, screen );

    XAllocNamedColor( dpy, cmap, "green", &color, &exact );
    green = color.pixel;

    XAllocNamedColor( dpy, cmap, "red", &color, &exact );
    red = color.pixel;
    
    XAllocNamedColor( dpy, cmap, "aqua", &color, &exact );
    aqua = color.pixel;
    
    XAllocNamedColor( dpy, cmap, "navy", &color, &exact );
    navy = color.pixel;
    
    win = XCreateSimpleWindow( dpy, root,
                            WIN_X, WIN_Y, WIN_W, WIN_H, BORDER, black, black);

    gc = XCreateGC( dpy, win, 0, NULL );

    XSelectInput( dpy, win, KeyPressMask | ExposureMask );

    XMapWindow( dpy, win );
    
    while( 1 ) {
        while ( XPending( dpy ) ) {
            
            XNextEvent( dpy, &evt );

            switch( evt.type ) {
        
                case Expose:
                    if ( evt.xexpose.count == 0 ) {
                        
                        //　画面のクリア
                        XClearWindow(dpy, win);
                        
                        // 描画色にnavyを設定
                        XSetForeground( dpy, gc, navy );
                        
                        //　線の描画
                        for (n=0; n<11; n++){
                            XDrawLine( dpy, win, gc, 6, n*30, 506, n*30);
                            XDrawLine( dpy, win, gc, 6+n*50, 0, 6+n*50, 300);
                        }
                        
                    }
                    break;
                    
                case KeyPress:
                    keysym = XKeycodeToKeysym(dpy, evt.xkey.keycode, 0);
                    switch(keysym){
                        case XK_Escape:
                            // リソースの解放
                            XFreeGC( dpy, gc );
                            XDestroyWindow( dpy, win );
                            XCloseDisplay( dpy );
                            return 0;
                            
                    }
             }
            
        }
        
    }
    
}

