LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_signed.all;

entity cic is
	generic(
		m:integer
		);
	port (
		CKin 	:  in std_logic;  						
		fin 	:  in std_logic_vector(9 downto 0); 
		fout  :  out std_logic_vector(9 downto 0) 
		);
end cic;
  
architecture ad of cic is

	constant N: integer :=40;
	
	signal cnt : std_logic_vector(9 downto 0) := "0000000000";
	
	signal b0  : std_logic_vector(N downto 0);	
	signal b1  : std_logic_vector(N downto 0);	
	signal b2  : std_logic_vector(N downto 0);	
	signal b3  : std_logic_vector(N downto 0);	
	signal b4  : std_logic_vector(N downto 0);	
	signal b5  : std_logic_vector(N downto 0);	
	signal b6  : std_logic_vector(N downto 0);	
	signal b7  : std_logic_vector(N downto 0);	
	signal b8  : std_logic_vector(N downto 0);	
	
	signal z0  : std_logic_vector(N downto 0);	
	signal z1  : std_logic_vector(N downto 0);	
	signal z2  : std_logic_vector(N downto 0);	
	signal z3  : std_logic_vector(N downto 0);	
	signal z4  : std_logic_vector(N downto 0);	
	signal z5  : std_logic_vector(N downto 0);	
	signal z6  : std_logic_vector(N downto 0);	
	signal z7  : std_logic_vector(N downto 0);	
	signal z8  : std_logic_vector(N downto 0);	
	
	signal v0  : std_logic_vector(N downto 0) := "00000000000000000000000000000000000000000";
	
	signal t0 : std_logic;  

begin
	
	process(CKin)
	begin
		if CKin'event and CKin = '1' then
			cnt <= cnt + '1';
		end if;
	end process;
	
	------------------------ CIC Integral filter
	process(CKin)
	begin
	   if CKin'event and CKin='1' then
			b1 <= z1 + fin;
			b2 <= z2 + b1;
			b3 <= z3 + b2;
			b4 <= z4 + b3;
			
			z1 <= b1;
			z2 <= b2;
			z3 <= b3;
			z4 <= b4;
		end if;
	end process;
	
	t0 <= '1' when cnt(m)='1' else '0';	
	
	process(t0)
	begin
	   if t0'event and t0='1' then
			b5 <= b4 - z5;
			b6 <= b5 - z6;
			b7 <= b6 - z7;
			b8 <= b7 - z8;
			
			z5 <= b4;
			z6 <= b5;
			z7 <= b6;
			z8 <= b7;
		end if;
	end process;
	
	fout <= b8(25 downto 16);				-- Gain 0dB at 1/32
	
end ad;

