LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY ram1 IS
	PORT (
		clock: 			IN STD_LOGIC;
		data: 			IN STD_LOGIC_VECTOR (9 DOWNTO 0);
		write_address: IN INTEGER RANGE 0 to 1023;
		read_address: 	IN INTEGER RANGE 0 to 1023;
		we: 				IN STD_LOGIC;
		q: 				OUT STD_LOGIC_VECTOR (9 DOWNTO 0)
	);
END ram1;

ARCHITECTURE rtl OF ram1 IS
	TYPE MEM IS ARRAY(0 TO 1023) OF STD_LOGIC_VECTOR(9 DOWNTO 0);
	SIGNAL ram_block: MEM;
BEGIN
	PROCESS (clock)
	BEGIN
		IF (clock'event AND clock = '1') THEN
			IF (we = '1') THEN
				ram_block(write_address) <= data;
			END IF;
			q <= ram_block(read_address);
		END IF;
	END PROCESS;
END rtl;